<script lang="ts">
	import Player from './Player.svelte';
	import Cell from './Cell.svelte';
	import { Game } from './game';
	import { GameMapMaker } from './gameMapMaker';
	import PatternSelector from './PatternSelector.svelte';

	export let gameHeight: number;
	export let gameWidth: number;

	let game = new Game(gameHeight, gameWidth);
	let mapMaker = new GameMapMaker(game);

	$: {
		console.log('Making new game');
		stopGame();
		game = new Game(gameHeight, gameWidth);
		mapMaker = new GameMapMaker(game);
	}

	let period = 1000;
	let forceUpdate = false;
	let gameRunning = false;

	// eslint-disable-next-line no-undef
	let intervalID: NodeJS.Timeout;

	let toggleHandler = (i: number) => {
		return () => {
			console.log('is alive', i, !game.isAlive(i));
			game.setAlive(i, !game.isAlive(i));
		};
	};
	let playGame = () => {
		gameRunning = true;
		intervalID = setInterval(() => {
			game.step();
			forceUpdate = !forceUpdate;
		}, period);
	};

	let stopGame = () => {
		clearInterval(intervalID);
		gameRunning = false;
	};
</script>

<PatternSelector
	chessBoardPattern={() => {
		game.clear();
		mapMaker.makeChessBoard();
		forceUpdate = !forceUpdate;
	}}
	CthulhuPattern={() => {
		game.clear();
		mapMaker.makeCthulhu();
		forceUpdate = !forceUpdate;
	}}
	gunPattern={() => {
		game.clear();
		mapMaker.makeGun();
		forceUpdate = !forceUpdate;
	}}
/>
<br />
<Player
	play={playGame}
	step={() => {
		stopGame();
		game.step();
		forceUpdate = !forceUpdate;
		return;
	}}
	stop={stopGame}
	reset={() => {
		stopGame();
		game.clear();
		forceUpdate = !forceUpdate;
	}}
	bind:period
	on:periodUpdate={(period) => {
		console.log('period updated', period);
		let gameWasRunning = gameRunning;
		stopGame();
		if (gameWasRunning) {
			playGame();
		}
	}}
/>
<div class="grid-container" style="--grid-height: {gameHeight}; --grid-width: {gameWidth}">
	{#each { length: gameHeight * gameWidth } as _, i}
		<Cell
			coordinate={i}
			isAlive={() => game.isAlive(i)}
			clickHandler={toggleHandler(i)}
			{forceUpdate}
		/>
	{/each}
</div>

<style>
	.grid-container {
		display: grid;
		grid-template-columns: repeat(var(--grid-width), 20px);
		grid-template-rows: repeat(var(--grid-height), 20px);
		background-color: #092d4a;
		padding: 10px;
	}
</style>
